//
// Customer.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation



public struct Customer: Codable {

    public enum CustomerContractType: String, Codable { 
        case free = "free"
        case demo = "demo"
        case pay = "pay"
    }
    /** Unique identifier for the customer */
    public var _id: Int64
    /** Company name */
    public var companyName: String
    /** Customer type */
    public var customerContractType: CustomerContractType
    /** Maximal disc space which can be allocated by customer in bytes. */
    public var quotaMax: Int64
    /** Used amount of disc space in bytes */
    public var quotaUsed: Int64
    /** Maximal number of users */
    public var userMax: Int
    /** Number of users which are already allocated. */
    public var userUsed: Int
    /** Customer lock status: * &#x60;false&#x60; - unlocked * &#x60;true&#x60; - locked  All users of this customer will be blocked and can not login anymore. (default: false) */
    public var lockStatus: Bool
    /** Creation date */
    public var createdAt: Date
    /** Customer activation code string: * valid only for types &#x60;free&#x60; and &#x60;demo&#x60; * for &#x60;pay&#x60; customers it is empty */
    public var activationCode: String?
    /** Number of days left for trial period (relevant only for type &#x60;demo&#x60;) */
    public var trialDaysLeft: Int?
    /** Provider customer ID value (relevant only for type &#x60;pay&#x60;) */
    public var providerCustomerId: String?
    /** Modification date */
    public var updatedAt: Date?
    /** Date of last seen login for the customer */
    public var lastLoginAt: Date?
    /** Customer attributes */
    public var customerAttributes: CustomerAttributes?


    public enum CodingKeys: String, CodingKey { 
        case _id = "id"
        case companyName
        case customerContractType
        case quotaMax
        case quotaUsed
        case userMax
        case userUsed
        case lockStatus
        case createdAt
        case activationCode
        case trialDaysLeft
        case providerCustomerId
        case updatedAt
        case lastLoginAt
        case customerAttributes
    }


}

